name: Release Creation

on:
  release:
    types: [published]

jobs:
  build:
    runs-on: ubuntu-latest
    steps:
    - run: echo "💡 The ${{ gitea.repository }} repository will be cloned to the runner."

    - uses: RouxAntoine/checkout@v3.5.4

    # get part of the tag after the `v`
    - name: Extract tag version number
      id: get_version
      uses: battila7/get-version-action@v2

    # Substitute the Manifest and Download URLs in the system.json
    - name: Substitute Manifest and Download Links For Versioned Ones
      id: sub_manifest_link_version
      uses: microsoft/variable-substitution@v1
      with:
        files: 'system.json'
      env:
        version: ${{steps.get_version.outputs.version-without-v}}
        url: https://www.uberwald.me/gitea/${{gitea.repository}}
        manifest: https://www.uberwald.me/gitea/public/fvtt-malefices/releases/download/latest/system.json
        download: https://www.uberwald.me/gitea/${{gitea.repository}}/releases/download/${{github.event.release.tag_name}}/fvtt-malefices.zip

    # Create a zip file with all files required by the system to add to the release
    - run: |
         apt update -y
         apt install -y zip

    - run: zip -r ./fvtt-malefices.zip system.json README.md fonts/ images/ lang/ modules/ packs/ styles/ templates/

    - name: setup go
      uses: https://github.com/actions/setup-go@v4
      with:
        go-version: '>=1.20.1'

    - name: Use Go Action
      id: use-go-action
      uses: https://gitea.com/actions/release-action@main
      with:
        files: |-
          ./fvtt-malefices.zip
          system.json
        api_key: '${{secrets.ALLOW_PUSH_RELEASE}}'

    - name: Publish to Foundry server
      uses: https://github.com/djlechuck/foundryvtt-publish-package-action@v1
      with:
        token: ${{ secrets.FOUNDRYVTT_RELEASE_TOKEN }}
        id: 'fvtt-malefices'
        version: ${{github.event.release.tag_name}}
        manifest: 'https://www.uberwald.me/gitea/public/fvtt-malefices/releases/download/latest/system.json'
        notes: 'https://www.uberwald.me/gitea/${{gitea.repository}}/releases/download/${{github.event.release.tag_name}}/fvtt-malefices.zip'
        compatibility-minimum: '13'
        compatibility-verified: '14'
